Hardware Locality (hwloc): Interoperability with OpenFabrics

Hardware Locality (hwloc) 2.14.0rc1

Functions
Interoperability with OpenFabrics

## Functions
int | hwloc_ibv_get_device_cpuset (hwloc_topology_t topology, struct ibv_device *ibdev, hwloc_cpuset_t set)
hwloc_obj_t | hwloc_ibv_get_device_osdev_by_name (hwloc_topology_t topology, const char *ibname)
hwloc_obj_t | hwloc_ibv_get_device_osdev (hwloc_topology_t topology, struct ibv_device *ibdev)

## Detailed Description

This interface offers ways to retrieve topology information about OpenFabrics devices (InfiniBand, Omni-Path, usNIC, etc).

## Function Documentation

## ◆ hwloc_ibv_get_device_cpuset()

int hwloc_ibv_get_device_cpuset | ( | hwloc_topology_t | topology,
|  | struct ibv_device * | ibdev,
|  | hwloc_cpuset_t | set )
| inline

Get the CPU set of processors that are physically close to device `ibdev`.

Store in `set` the CPU-set describing the locality of the OpenFabrics device `ibdev` (InfiniBand, etc).

Topology `topology` and device `ibdev` must match the local machine. I/O devices detection is not needed in the topology.

The function only returns the locality of the device. If more information about the device is needed, OS objects should be used instead, see hwloc_ibv_get_device_osdev() and hwloc_ibv_get_device_osdev_by_name().

This function is currently only implemented in a meaningful way for Linux; other systems will simply get the cpuset of the entire topology.

Returns
  0 on success.
  -1 on error, for instance if device information could not be found.

## ◆ hwloc_ibv_get_device_osdev()

hwloc_obj_t hwloc_ibv_get_device_osdev | ( | hwloc_topology_t | topology,
|  | struct ibv_device * | ibdev )
| inline

Get the hwloc OS device object corresponding to the OpenFabrics device `ibdev`.

Returns
  The hwloc OS device object describing the OpenFabrics device `ibdev` (InfiniBand, etc).
  `NULL` if none could be found.

Topology `topology` and device `ibdev` must match the local machine. I/O devices detection must be enabled in the topology. If not, the locality of the object may still be found using hwloc_ibv_get_device_cpuset().

Note
  The corresponding PCI device object can be obtained by looking at the OS device parent object.

## ◆ hwloc_ibv_get_device_osdev_by_name()

hwloc_obj_t hwloc_ibv_get_device_osdev_by_name | ( | hwloc_topology_t | topology,
|  | const char * | ibname )
| inline

Get the hwloc OS device object corresponding to the OpenFabrics device named `ibname`.

Returns
  The hwloc OS device object describing the OpenFabrics device (InfiniBand, Omni-Path, usNIC, etc) whose name is `ibname` (mlx5_0, hfi1_0, usnic_0, qib0, etc).
  `NULL` if none could be found.

The name `ibname` is usually obtained from ibv_get_device_name().

The topology `topology` does not necessarily have to match the current machine. For instance the topology may be an XML import of a remote host. I/O devices detection must be enabled in the topology.

Note
  The corresponding PCI device object can be obtained by looking at the OS device parent object.